#include <avr/io.h>
#include <avr/interrupt.h>  /* for sei() */
#include <util/delay.h>     /* for _delay_ms() */
#include <avr/pgmspace.h>   /* required by usbdrv.h */
#include "usbdrv.h"
#include <math.h>
#define RQ_GET_SOUND    0
#define RQ_GET_NEW_VALUE_SOUND    1
/* ------------------------------------------------------------------------- */
/* ----------------------------- USB interface ----------------------------- */
/* ------------------------------------------------------------------------- */
uint16_t read_adc(uint8_t channel){
	ADMUX = 0b01000000;
	ADMUX |= channel;
	ADCSRA = 0b11000110;
	while((ADCSRA & (1<<ADSC)));
	return ADCL+ADCH*256;

}
static uint16_t sound;
usbMsgLen_t usbFunctionSetup(uint8_t data[8])
{
    usbRequest_t *rq = (void *)data;

    if (rq->bRequest == RQ_GET_SOUND)
    {
        sound = read_adc(rq->wValue.bytes[0]);
        usbMsgPtr = (uchar*) &sound;

        return sizeof(sound);
    }
	else if (rq->bRequest == RQ_GET_NEW_VALUE_SOUND)
    {
		int i;
		int j;
		int max[5]={0,0,0,0,0};
//		int init[5]={782,630,600,0,575};
		int maxx=0;
		int index=9;
		uint16_t sound2;
		for(i=0;i<1;i++)
		{
			for(j=0;j<5;j++)
			{
				if(j==3)
				continue;
        		sound = read_adc(j);
				sound2  = read_adc(j);
				if(sound>max[j])
				{
 					max[j]= (sound-sound2);
				}
				
			}
		}
		
		for(j=0;j<5;j++)
		{
			if(max[j]>maxx&& max[j]>50)
			{
				maxx=max[j];
				index=j;
			}
		}
		sound=max[4];

        usbMsgPtr = (uchar*) &sound;
        return sizeof(sound);
    }
    return 0;   /* default for not implemented requests: return no data back to host */
}

/* ------------------------------------------------------------------------- */

int main(void)
{
    //DDRC  = (1<<PC0)|(1<<PC1)|(1<<PC2); // PC0..PC2 = Output, PC3..PC5 = Input
//    PORTC = (1<<PC4)|(1<<PC0)|(1<<PC1)|(1<<PC2);                 // Enable pull-up at PC3

    usbInit();

    /* enforce re-enumeration, do this while interrupts are disabled! */
    usbDeviceDisconnect();
    _delay_ms(300);
    usbDeviceConnect();

    /* enable global interrupts */
    sei();

    /* main event loop */
    for(;;)
    {
        usbPoll();
    }

    return 0;
}

/* ------------------------------------------------------------------------- */
